VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsTastih"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'########### Tastih Arazi v1.0 CLASS ################
'########### Programmer: Nabi Karamalizadeh #########
'########### http://www.Tastih.Nabi.ir/ #############
'########### Copyright 2007 All rights reserved. ####

Dim dZ() As Single
Const C34 = """"
Const Cr = vbCr

Private Type typOutput
    N As Single
    dX As Single
    dY As Single
    R As Single
    Xc As Single
    Yc As Single
    Zc As Single
    X2 As Single
    Y2 As Single
    XY As Single
    XZ As Single
    YZ As Single
    a1 As Single
    b1 As Single
    c1 As Single
    a2 As Single
    b2 As Single
    c2 As Single
    Sx As Single
    Sy As Single
    Sx1 As Single
    Sy1 As Single
    Sx2 As Single
    Sy2 As Single
    CUT_first As Single
    FILL_first As Single
    Nc_first As Single
    Nf_first As Single
    NOCF_first As Single
    r_first As Single
    d As Single
    CUT_final As Single
    FILL_final As Single
    Nc_final As Single
    Nf_final As Single
    NOCF_final As Single
    r_final As Single
    dZ_string_first() As String
    dZ_string_final() As String
    b() As Single
    c() As Single
End Type
Dim OutputData As typOutput

Private Type typInput
    a() As Single
    x0 As Single
    y0 As Single
    dX As Single
    dY As Single
    R As Single
    Sx1 As Single
    Sx2 As Single
    Sy1 As Single
    Sy2 As Single
    CheckShib As Boolean
    XcManual As Single
    YcManual As Single
    CheckCentroid As Boolean
End Type
Dim InputData As typInput

Function Run()
On Error Resume Next

ReDim OutputData.b(InputData.x0, InputData.y0)
ReDim OutputData.c(InputData.x0, InputData.y0)
ReDim dZ(InputData.x0, InputData.y0)
ReDim OutputData.dZ_string_first(InputData.x0, InputData.y0)
ReDim OutputData.dZ_string_final(InputData.x0, InputData.y0)

OutputData.R = InputData.R
OutputData.dX = InputData.dX
OutputData.dY = InputData.dY

For i = 1 To InputData.x0
        For j = 1 To InputData.y0
                If InputData.a(i, j) <> 0 Then N = N + 1
        Next j
Next i
OutputData.N = N

If InputData.CheckCentroid = True Then
    For i = 1 To InputData.y0
            For j = 1 To InputData.x0
                    If InputData.a(j, i) <> 0 Then Xc0 = Xc0 + j * InputData.dX
            Next j
    Next i
    Xc = Xc0 / N
    OutputData.Xc = Xc
Else
    Xc = InputData.XcManual
    OutputData.Xc = InputData.XcManual
End If

If InputData.CheckCentroid = True Then
    For i = 1 To InputData.x0
            For j = 1 To InputData.y0
                    If InputData.a(i, j) <> 0 Then Yc0 = Yc0 + j * InputData.dY
            Next j
    Next i
    Yc = Yc0 / N
    OutputData.Yc = Yc
Else
    Yc = InputData.YcManual
    OutputData.Yc = InputData.YcManual
End If

For i = 1 To InputData.x0
        For j = 1 To InputData.y0
                If InputData.a(i, j) <> 0 Then Zc0 = Zc0 + InputData.a(i, j)
        Next j
Next i
Zc = Zc0 / N
OutputData.Zc = Zc

For j = 1 To InputData.y0
        For i = 1 To InputData.x0
                If InputData.a(i, j) <> 0 Then X2 = X2 + (i * InputData.dX) ^ 2
        Next i
Next j

For i = 1 To InputData.x0
        For j = 1 To InputData.y0
                If InputData.a(i, j) <> 0 Then Y2 = Y2 + (j * InputData.dY) ^ 2
        Next j
Next i

For i = 1 To InputData.x0
        For j = 1 To InputData.y0
                If InputData.a(i, j) <> 0 Then XY = XY + (i * InputData.dX) * (j * InputData.dY)
        Next j
Next i

For i = 1 To InputData.x0
        For j = 1 To InputData.y0
                If InputData.a(i, j) <> 0 Then XZ = XZ + (i * InputData.dX) * InputData.a(i, j)
        Next j
Next i

For j = 1 To InputData.y0
        For i = 1 To InputData.x0
                If InputData.a(i, j) <> 0 Then YZ = YZ + (j * InputData.dY) * InputData.a(i, j)
        Next i
Next j
OutputData.X2 = X2
OutputData.Y2 = Y2
OutputData.XY = XY
OutputData.XZ = XZ
OutputData.YZ = YZ

a1 = X2 - N * Xc ^ 2
b1 = XY - N * Xc * Yc
c1 = XZ - N * Xc * Zc
a2 = XY - N * Xc * Yc
b2 = Y2 - N * Yc ^ 2
c2 = YZ - N * Yc * Zc
OutputData.a1 = a1
OutputData.b1 = b1
OutputData.c1 = c1
OutputData.a2 = a2
OutputData.b2 = b2
OutputData.c2 = c2

Sy = (c1 - (a1 * c2 / a2)) / (b1 - (a1 * b2 / a2))
Sx = (c1 - b1 * y) / a1
OutputData.Sy = Sy
OutputData.Sx = Sx

If InputData.CheckShib = True Then
    OutputData.Sx1 = InputData.Sx1
    OutputData.Sx2 = InputData.Sx2
    OutputData.Sy1 = InputData.Sy1
    OutputData.Sy2 = InputData.Sy2
    Sx1 = InputData.Sx1 / 100
    Sx2 = InputData.Sx2 / 100
    Sy1 = InputData.Sy1 / 100
    Sy2 = InputData.Sy2 / 100
    If Sx < 0 Then Sx1 = -Sx1: Sx2 = -Sx2
    If Sy < 0 Then Sy1 = -Sy1: Sy2 = -Sy2
    dSx1 = Abs(Sx - Sx1)
    dSx2 = Abs(Sx - Sx2)
    
    dSy1 = Abs(Sy - Sy1)
    dSy2 = Abs(Sy - Sy2)
    
    If dSx1 < dSx2 Then Sx = Sx1 Else Sx = Sx2
    If dSy1 < dSy2 Then Sy = Sy1 Else Sy = Sy2
    
    OutputData.Sy = Sy
    OutputData.Sx = Sx
End If

ZA0 = Zc - Xc * Sx - Yc * Sy
For i = 1 To InputData.x0
        For j = 1 To InputData.y0
                If InputData.a(i, j) <> 0 Then
                        OutputData.b(i, j) = ZA0 + i * InputData.dX * Sx + j * InputData.dY * Sy
                        OutputData.b(i, j) = Format(OutputData.b(i, j), "##.##")
                End If
        Next j
Next i

For i = 1 To InputData.x0
        For j = 1 To InputData.y0
                If InputData.a(i, j) <> 0 Then
                    dZ(i, j) = InputData.a(i, j) - OutputData.b(i, j)
                    dZ(i, j) = Round(dZ(i, j), 2)
                    If dZ(i, j) > 0 Then CUT = CUT + dZ(i, j): Nc = Nc + 1
                    If dZ(i, j) < 0 Then FILL = FILL + dZ(i, j): Nf = Nf + 1
                    If dZ(i, j) = 0 Then NOCF = NOCF + 1
                End If
        Next j
Next i
OutputData.CUT_first = Format(Abs(CUT), "##.###")
OutputData.FILL_first = Format(Abs(FILL), "##.###")
OutputData.r_first = OutputData.CUT_first / OutputData.FILL_first
OutputData.Nc_first = Nc
OutputData.Nf_first = Nf
OutputData.NOCF_first = NOCF
d = ((1 + InputData.R) / (2 * InputData.R * N)) * (InputData.R * OutputData.FILL_first - OutputData.CUT_first)
OutputData.d = Format(d, "##.###")

If OutputData.r_first > InputData.R Then d = -d

For i = 1 To InputData.x0
        For j = 1 To InputData.y0
                If InputData.a(i, j) <> 0 Then
                        If dZ(i, j) > 0 Then OutputData.dZ_string_first(i, j) = Format(Abs(dZ(i, j)), "##.##") & " <font color=red>C</font>"
                        If dZ(i, j) < 0 Then OutputData.dZ_string_first(i, j) = Format(Abs(dZ(i, j)), "##.##") & " <font color=blue>F</font>"
                        If dZ(i, j) = 0 Then OutputData.dZ_string_first(i, j) = "<font color=#FF00FF>0</font>"
                        dZ(i, j) = dZ(i, j) + d
                        dZ(i, j) = Round(dZ(i, j), 2)
                        If dZ(i, j) > 0 Then OutputData.dZ_string_final(i, j) = Format(Abs(dZ(i, j)), "##.##") & " <font color=red>C</font>"
                        If dZ(i, j) < 0 Then OutputData.dZ_string_final(i, j) = Format(Abs(dZ(i, j)), "##.##") & " <font color=blue>F</font>"
                        If dZ(i, j) = 0 Then OutputData.dZ_string_final(i, j) = "<font color=#FF00FF>0</font>"
                        OutputData.c(i, j) = InputData.a(i, j) - dZ(i, j)
                        OutputData.c(i, j) = Round(OutputData.c(i, j), 2)
                       
                End If
        Next j
Next i
CUT = 0
FILL = 0
Nc = 0
Nf = 0
NOCF = 0
For i = 1 To InputData.x0
        For j = 1 To InputData.y0
                If InputData.a(i, j) <> 0 Then
                    If dZ(i, j) > 0 Then CUT = CUT + dZ(i, j): Nc = Nc + 1
                    If dZ(i, j) < 0 Then FILL = FILL + dZ(i, j): Nf = Nf + 1
                    If dZ(i, j) = 0 Then NOCF = NOCF + 1
                End If
        Next j
Next i
OutputData.CUT_final = Format(Abs(CUT), "##.###")
OutputData.FILL_final = Format(Abs(FILL), "##.###")
OutputData.r_final = OutputData.CUT_final / OutputData.FILL_final
OutputData.Nc_final = Nc
OutputData.Nf_final = Nf
OutputData.NOCF_final = NOCF

Close
End Function

Public Sub CreateFile(FileName As String)

Open FileName For Output As #1

Print #1, "<html>"
Print #1, ""
Print #1, "<head>"
Print #1, "<meta http-equiv=" & Chr(34) & "Content-Type" & Chr(34) & " content=" & Chr(34) & "text/html; charset=windows-1252" & Chr(34) & ">"
Print #1, "<title>report tastih v1.0</title>"
Print #1, "</head>"
Print #1, "<style type=" & Chr(34) & "text/css" & Chr(34) & ">"
Print #1, "<!--"
Print #1, "td {"
Print #1, "font-family: tahoma, arial;"
Print #1, "font-size: 12px;"
Print #1, "}"
Print #1, "-->"
Print #1, "</style>"
Print #1, "<body>"
Print #1, ""
Print #1, "<table border=" & Chr(34) & "1" & Chr(34) & " width=" & Chr(34) & "100%" & Chr(34) & " id=" & Chr(34) & "table1" & Chr(34) & ">"
Print #1, " <tr>"
Print #1, "     <td>"
Print #1, "     <table border=" & Chr(34) & "0" & Chr(34) & " width=" & Chr(34) & "100%" & Chr(34) & " id=" & Chr(34) & "table13" & Chr(34) & " cellspacing=" & Chr(34) & "5" & Chr(34) & " cellpadding=" & Chr(34) & "0" & Chr(34) & " bgcolor=" & Chr(34) & "#000080" & Chr(34) & ">"
Print #1, "         <tr>"
Print #1, "             <td dir=" & Chr(34) & "rtl" & Chr(34) & " width=" & Chr(34) & "50%" & Chr(34) & "><b><span lang=" & Chr(34) & "fa" & Chr(34) & "><font color=" & Chr(34) & "#FFFFFF" & Chr(34) & ">"
Print #1, "             &#1606;&#1585;&#1605; &#1575;&#1601;&#1586;&#1575;&#1585; &#1578;&#1587;&#1591;&#1740;&#1581; "
Print #1, "             &#1575;&#1585;&#1575;&#1590;&#1740; &#1606;&#1587;&#1582;&#1607; &#1575;&#1608;&#1604;</font></span></b></td>"
Print #1, "             <td dir=" & Chr(34) & "rtl" & Chr(34) & " width=" & Chr(34) & "50%" & Chr(34) & "><b><span lang=" & Chr(34) & "fa" & Chr(34) & "><font color=" & Chr(34) & "#FFFFFF" & Chr(34) & ">&#1576;&#1585;&#1606;&#1575;&#1605;&#1607; &#1606;&#1608;&#1740;&#1587;: "
Print #1, "             &#1606;&#1576;&#1740; &#1705;&#1585;&#1605;&#1593;&#1604;&#1740; &#1586;&#1575;&#1583;&#1607;</font></span></b></td>"
Print #1, "         </tr>"
Print #1, "     </table>"
Print #1, "     </td>"
Print #1, " </tr>"
Print #1, " <tr>"
Print #1, "     <td>"
Print #1, "     <table border=" & Chr(34) & "0" & Chr(34) & " width=" & Chr(34) & "100%" & Chr(34) & " id=" & Chr(34) & "table2" & Chr(34) & " cellspacing=" & Chr(34) & "0" & Chr(34) & " cellpadding=" & Chr(34) & "0" & Chr(34) & ">"
Print #1, "         <tr>"
Print #1, "             <td>Xc = <b>" & OutputData.Xc & "</b></td>"
Print #1, "             <td>Yc = <b>" & OutputData.Yc & "</b></td>"
Print #1, "             <td>Zc = <b>" & OutputData.Zc & "</b></td>"
Print #1, "         </tr>"
Print #1, "     </table>"
Print #1, "     </td>"
Print #1, " </tr>"
Print #1, " <tr>"
Print #1, "     <td>"
Print #1, "     <table border=" & Chr(34) & "0" & Chr(34) & " width=" & Chr(34) & "100%" & Chr(34) & " id=" & Chr(34) & "table3" & Chr(34) & " cellspacing=" & Chr(34) & "0" & Chr(34) & " cellpadding=" & Chr(34) & "0" & Chr(34) & ">"
Print #1, "         <tr>"
Print #1, "             <td>N=<b>" & OutputData.N & "</b></td>"
Print #1, "             <td>Dx=<b>" & OutputData.dX & "</b></td>"
Print #1, "             <td>Dy=<b>" & OutputData.dY & "</b></td>"
Print #1, "             <td>R=<b>" & OutputData.R & "</b></td>"
Print #1, "         </tr>"
Print #1, "     </table>"
Print #1, "     </td>"
Print #1, " </tr>"
If InputData.CheckShib = True Then
Print #1, " <tr>"
Print #1, "     <td>"
Print #1, "     <table border=" & Chr(34) & "0" & Chr(34) & " width=" & Chr(34) & "100%" & Chr(34) & " id=" & Chr(34) & "table4" & Chr(34) & " cellspacing=" & Chr(34) & "0" & Chr(34) & " cellpadding=" & Chr(34) & "0" & Chr(34) & ">"
Print #1, "         <tr>"
Print #1, "             <td>Sx(first)= ( <b>" & OutputData.Sx1 & "</b> , <b>" & OutputData.Sx2 & "</b> )</td>"
Print #1, "             <td>Sy(first)= ( <b>" & OutputData.Sy1 & "</b> , <b>" & OutputData.Sy2 & "</b> )</td>"
Print #1, "         </tr>"
Print #1, "     </table>"
Print #1, "     </td>"
Print #1, " </tr>"
End If
Print #1, " <tr>"
Print #1, "     <td>"
Print #1, "     <table border=" & Chr(34) & "0" & Chr(34) & " width=" & Chr(34) & "100%" & Chr(34) & " id=" & Chr(34) & "table5" & Chr(34) & " cellspacing=" & Chr(34) & "0" & Chr(34) & " cellpadding=" & Chr(34) & "0" & Chr(34) & ">"
Print #1, "         <tr>"
Print #1, "             <td>sigma(X^2)=<b>" & OutputData.X2 & "</b></td>"
Print #1, "             <td>sigma(Y^2)=<b>" & OutputData.Y2 & "</b></td>"
Print #1, "             <td>sigma(X*Y)=<b>" & OutputData.XY & "</b></td>"
Print #1, "             <td>sigma(X*Z)=<b>" & OutputData.XZ & "</b></td>"
Print #1, "             <td>sigma(Y*Z)=<b>" & OutputData.YZ & "</b></td>"
Print #1, "         </tr>"
Print #1, "     </table>"
Print #1, "     </td>"
Print #1, " </tr>"
Print #1, " <tr>"
Print #1, "     <td>"
Print #1, "     <table border=" & Chr(34) & "0" & Chr(34) & " width=" & Chr(34) & "100%" & Chr(34) & " id=" & Chr(34) & "table6" & Chr(34) & " cellspacing=" & Chr(34) & "0" & Chr(34) & " cellpadding=" & Chr(34) & "0" & Chr(34) & ">"
Print #1, "         <tr>"
Print #1, "             <td>Sx* (<b>" & OutputData.a1 & "</b>) + Sy* (<b>" & OutputData.b1 & "</b>) = <b>" & OutputData.c1 & "</b></td>"
Print #1, "             <td>Sy* (<b>" & OutputData.b2 & "</b>) + Sx* (<b>" & OutputData.a2 & "</b>) = <b>" & OutputData.c2 & "</b></td>"
Print #1, "         </tr>"
Print #1, "     </table>"
Print #1, "     </td>"
Print #1, " </tr>"
Print #1, " <tr>"
Print #1, "     <td>"
Print #1, "     <table border=" & Chr(34) & "0" & Chr(34) & " width=" & Chr(34) & "100%" & Chr(34) & " id=" & Chr(34) & "table7" & Chr(34) & " cellspacing=" & Chr(34) & "0" & Chr(34) & " cellpadding=" & Chr(34) & "0" & Chr(34) & ">"
Print #1, "         <tr>"
Print #1, "             <td>Sx=<b>" & OutputData.Sx & "</b></td>"
Print #1, "             <td>Sy=<b>" & OutputData.Sy & "</b></td>"
Print #1, "         </tr>"
Print #1, "     </table>"
Print #1, "     </td>"
Print #1, " </tr>"
Print #1, " <tr>"
Print #1, "     <td>"
Print #1, "     <table border=" & Chr(34) & "0" & Chr(34) & " width=" & Chr(34) & "100%" & Chr(34) & " id=" & Chr(34) & "table8" & Chr(34) & " cellspacing=" & Chr(34) & "0" & Chr(34) & " cellpadding=" & Chr(34) & "0" & Chr(34) & ">"
Print #1, "         <tr>"
Print #1, "             <td>CUT (first)=<b>" & OutputData.CUT_first & "</b></td>"
Print #1, "             <td>FILL (first)=<b>" & OutputData.FILL_first & "</b></td>"
Print #1, "         </tr>"
Print #1, "     </table>"
Print #1, "     </td>"
Print #1, " </tr>"
Print #1, " <tr>"
Print #1, "     <td>"
Print #1, "     <table border=" & Chr(34) & "0" & Chr(34) & " width=" & Chr(34) & "100%" & Chr(34) & " id=" & Chr(34) & "table9" & Chr(34) & " cellspacing=" & Chr(34) & "0" & Chr(34) & " cellpadding=" & Chr(34) & "0" & Chr(34) & ">"
Print #1, "         <tr>"
Print #1, "             <td>Nc=<b>" & OutputData.Nc_first & "</b></td>"
Print #1, "             <td>Nf=<b>" & OutputData.Nf_first & "</b></td>"
Print #1, "             <td>No Cut/Fill=<b>" & OutputData.NOCF_first & "</b></td>"
Print #1, "         </tr>"
Print #1, "     </table>"
Print #1, "     </td>"
Print #1, " </tr>"
Print #1, " <tr>"
Print #1, "     <td>"
Print #1, "     <table border=" & Chr(34) & "0" & Chr(34) & " width=" & Chr(34) & "100%" & Chr(34) & " id=" & Chr(34) & "table9" & Chr(34) & " cellspacing=" & Chr(34) & "0" & Chr(34) & " cellpadding=" & Chr(34) & "0" & Chr(34) & ">"
Print #1, "         <tr>"
Print #1, "             <td>R(first)=<b>" & OutputData.r_first & "</b></td>"
Print #1, "             <td>d=<b>" & OutputData.d & "</b></td>"
Print #1, "         </tr>"
Print #1, "     </table>"
Print #1, "     </td>"
Print #1, " </tr>"
Print #1, " <tr>"
Print #1, "     <td>"
Print #1, "     <table border=" & Chr(34) & "1" & Chr(34) & " width=" & Chr(34) & "100%" & Chr(34) & " id=" & Chr(34) & "table12" & Chr(34) & " bordercolor=" & Chr(34) & "#000000" & Chr(34) & " cellspacing=" & Chr(34) & "0" & Chr(34) & " style=" & Chr(34) & "border-collapse: collapse" & Chr(34) & " cellpadding=" & Chr(34) & "2" & Chr(34) & ">"
Print #1, "         <tr>"
Print #1, "             <td bgcolor=" & Chr(34) & "#000080" & Chr(34) & " align=" & Chr(34) & "center" & Chr(34) & "><b><font color=" & Chr(34) & "#FFFFFF" & Chr(34) & ">(x) &#1591;&#1608;&#1604;</font></b></td>"
Print #1, "             <td bgcolor=" & Chr(34) & "#000080" & Chr(34) & " align=" & Chr(34) & "center" & Chr(34) & "><b><font color=" & Chr(34) & "#FFFFFF" & Chr(34) & ">(y) &#1593;&#1585;&#1590;</font></b></td>"
Print #1, "             <td bgcolor=" & Chr(34) & "#000080" & Chr(34) & " align=" & Chr(34) & "center" & Chr(34) & "><b><font color=" & Chr(34) & "#FFFFFF" & Chr(34) & ">(z) &#1575;&#1585;&#1578;&#1601;&#1575;&#1593; &#1575;&#1608;&#1604;&#1610;&#1607;</font></b></td>"
Print #1, "             <td bgcolor=" & Chr(34) & "#000080" & Chr(34) & " align=" & Chr(34) & "center" & Chr(34) & "><b><font color=" & Chr(34) & "#FFFFFF" & Chr(34) & ">(z) &#1575;&#1585;&#1578;&#1601;&#1575;&#1593; &#1576;&#1593;&#1583; &#1575;&#1586; &#1578;&#1587;&#1591;&#1610;&#1581; &#1578;&#1589;&#1581;&#1610;&#1581; &#1606;&#1588;&#1583;&#1607;</font></b></td>"
Print #1, "             <td bgcolor=" & Chr(34) & "#000080" & Chr(34) & " align=" & Chr(34) & "center" & Chr(34) & "><b><font color=" & Chr(34) & "#FFFFFF" & Chr(34) & ">(dZ) &#1605;&#1602;&#1583;&#1575;&#1585; &#1608; &#1606;&#1608;&#1593; &#1593;&#1605;&#1604;&#1610;&#1575;&#1578; &#1582;&#1575;&#1705;&#1740; &#1602;&#1576;&#1604; &#1575;&#1586; &#1578;&#1589;&#1581;&#1610;&#1581;</font></b></td>"
Print #1, "             <td bgcolor=" & Chr(34) & "#000080" & Chr(34) & " align=" & Chr(34) & "center" & Chr(34) & "><b><font color=" & Chr(34) & "#FFFFFF" & Chr(34) & ">(dZ) &#1605;&#1602;&#1583;&#1575;&#1585; &#1608; &#1606;&#1608;&#1593; &#1593;&#1605;&#1604;&#1610;&#1575;&#1578; &#1582;&#1575;&#1705;&#1740; &#1576;&#1593;&#1583; &#1575;&#1586; &#1578;&#1589;&#1581;&#1610;&#1581;</font></b></td>"
Print #1, "             <td bgcolor=" & Chr(34) & "#000080" & Chr(34) & " align=" & Chr(34) & "center" & Chr(34) & "><b><font color=" & Chr(34) & "#FFFFFF" & Chr(34) & ">(z) &#1575;&#1585;&#1578;&#1601;&#1575;&#1593; &#1606;&#1607;&#1575;&#1740;&#1740; &#1578;&#1589;&#1581;&#1740;&#1581; &#1588;&#1583;&#1607;</font></b></td>"
Print #1, "         </tr>"
color1 = "#F0F0FF"
color2 = "#F4F4FF"
For i = 1 To InputData.x0
        For j = 1 To InputData.y0
                If InputData.a(i, j) <> 0 Then
                    If color_flag = False Then
                        color0 = color1
                        color_flag = True
                    Else
                        color0 = color2
                        color_flag = False
                    End If
Print #1, "         <tr>"
Print #1, "             <td align=" & Chr(34) & "center" & Chr(34) & " bgcolor=" & Chr(34) & color0 & Chr(34) & "><b>" & i & "</b></td>"
Print #1, "             <td align=" & Chr(34) & "center" & Chr(34) & " bgcolor=" & Chr(34) & color0 & Chr(34) & "><b>" & j & "</b></td>"
Print #1, "             <td align=" & Chr(34) & "center" & Chr(34) & " bgcolor=" & Chr(34) & color0 & Chr(34) & "><b>" & InputData.a(i, j) & "</b></td>"
Print #1, "             <td align=" & Chr(34) & "center" & Chr(34) & " bgcolor=" & Chr(34) & color0 & Chr(34) & "><b>" & OutputData.b(i, j) & "</b></td>"
Print #1, "             <td align=" & Chr(34) & "center" & Chr(34) & " bgcolor=" & Chr(34) & color0 & Chr(34) & "><b>" & OutputData.dZ_string_first(i, j) & "</b></td>"
Print #1, "             <td align=" & Chr(34) & "center" & Chr(34) & " bgcolor=" & Chr(34) & color0 & Chr(34) & "><b>" & OutputData.dZ_string_final(i, j) & "</b></td>"
Print #1, "             <td align=" & Chr(34) & "center" & Chr(34) & " bgcolor=" & Chr(34) & color0 & Chr(34) & "><b>" & OutputData.c(i, j) & "</b></td>"
Print #1, "         </tr>"
                End If
        Next j
Next i

Print #1, "     </table>"
Print #1, "     </td>"
Print #1, " </tr>"
Print #1, " <tr>"
Print #1, "     <td>"
Print #1, "     <table border=" & Chr(34) & "0" & Chr(34) & " width=" & Chr(34) & "100%" & Chr(34) & " id=" & Chr(34) & "table10" & Chr(34) & " cellspacing=" & Chr(34) & "0" & Chr(34) & " cellpadding=" & Chr(34) & "0" & Chr(34) & ">"
Print #1, "         <tr>"
Print #1, "             <td>CUT (final)=<b>" & OutputData.CUT_final & "</b></td>"
Print #1, "             <td>FILL (final)=<b>" & OutputData.FILL_final & "</b></td>"
Print #1, "         </tr>"
Print #1, "     </table>"
Print #1, "     </td>"
Print #1, " </tr>"
Print #1, " <tr>"
Print #1, "     <td>"
Print #1, "     <table border=" & Chr(34) & "0" & Chr(34) & " width=" & Chr(34) & "100%" & Chr(34) & " id=" & Chr(34) & "table11" & Chr(34) & " cellspacing=" & Chr(34) & "0" & Chr(34) & " cellpadding=" & Chr(34) & "0" & Chr(34) & ">"
Print #1, "         <tr>"
Print #1, "             <td>Nc (final)=<b>" & OutputData.Nc_final & "</b></td>"
Print #1, "             <td>Nf (final)=<b>" & OutputData.Nf_final & "</b></td>"
Print #1, "             <td>No Cut/Fill (final)=<b>" & OutputData.NOCF_final & "</b></td>"
Print #1, "         </tr>"
Print #1, "     </table>"
Print #1, "     </td>"
Print #1, " </tr>"
Print #1, " <tr>"
Print #1, "     <td>R(final)=<b>" & OutputData.r_final & "</b></td>"
Print #1, " </tr>"
Print #1, " <tr>"
Print #1, "     <td><p align=" & Chr(34) & "right" & Chr(34) & " dir=" & Chr(34) & "rtl" & Chr(34) & "><b>&#1578;&#1608;&#1580;&#1607;: </b>&#1608;&#1575;&#1581;&#1583; &#1605;&#1602;&#1575;&#1583;&#1740;&#1585; &#1582;&#1585;&#1608;&#1580;&#1740; &#1576;&#1585;&#1575;&#1576;&#1585; &#1608;&#1575;&#1581;&#1583; &#1605;&#1602;&#1575;&#1583;&#1740;&#1585; &#1608;&#1585;&#1608;&#1583;&#1740; &#1588;&#1605;&#1575; &#1605;&#1740; &#1576;&#1575;&#1588;&#1583;.</td>"
Print #1, " </tr>"
Print #1, " <tr>"
Print #1, "     <td>"
Print #1, "     <table border=" & Chr(34) & "0" & Chr(34) & " width=" & Chr(34) & "100%" & Chr(34) & " id=" & Chr(34) & "table14" & Chr(34) & " cellspacing=" & Chr(34) & "5" & Chr(34) & " cellpadding=" & Chr(34) & "0" & Chr(34) & " bgcolor=" & Chr(34) & "#000080" & Chr(34) & ">"
Print #1, "         <tr>"
Print #1, "             <td>"
Print #1, "             <p align=" & Chr(34) & "center" & Chr(34) & ">"
Print #1, "             <a target=" & Chr(34) & "_blank" & Chr(34) & " href=" & Chr(34) & "http://www.Tastih.Nabi.ir/" & Chr(34) & ">"
Print #1, "             <font color=" & Chr(34) & "#FFFFFF" & Chr(34) & ">http://www.Tastih.Nabi.ir/</font></a></td>"
Print #1, "         </tr>"
Print #1, "     </table>"
Print #1, "     </td>"
Print #1, " </tr>"
Print #1, "</table>"
Print #1, ""
Print #1, "</body>"
Print #1, ""
Print #1, "</html>"

Close #1
End Sub

Property Get in_X0() As Single
    in_X0 = InputData.x0
End Property

Property Let in_X0(tx0 As Single)
    InputData.x0 = tx0
End Property

Property Get in_Y0() As Single
    in_Y0 = InputData.y0
End Property

Property Let in_Y0(ty0 As Single)
    InputData.y0 = ty0
End Property

Property Get in_dX() As Single
    in_dX = InputData.dX
End Property

Property Let in_dX(tdX As Single)
    InputData.dX = tdX
End Property

Property Get in_dY() As Single
    in_dY = InputData.dY
End Property

Property Let in_dY(tdY As Single)
    InputData.dY = tdY
End Property

Property Get in_R() As Single
    in_R = InputData.R
End Property

Property Let in_R(tR As Single)
    InputData.R = tR
End Property

Property Get in_Sx1() As Single
    in_Sx1 = InputData.Sx1
End Property

Property Let in_Sx1(tSx1 As Single)
    InputData.Sx1 = tSx1
End Property

Property Get in_Sx2() As Single
    in_Sx2 = InputData.Sx2
End Property

Property Let in_Sx2(tSx2 As Single)
    InputData.Sx2 = tSx2
End Property

Property Get in_Sy1() As Single
    in_Sy1 = InputData.Sy1
End Property

Property Let in_Sy1(tSy1 As Single)
    InputData.Sy1 = tSy1
End Property

Property Get in_Sy2() As Single
    in_Sy2 = InputData.Sy2
End Property

Property Let in_Sy2(tSy2 As Single)
    InputData.Sy2 = tSy2
End Property

Property Get in_CheckShib() As Boolean
    in_CheckShib = InputData.CheckShib
End Property

Property Let in_CheckShib(tCheckShib As Boolean)
    InputData.CheckShib = tCheckShib
End Property
    
Property Get in_XcManual() As Single
    in_XcManual = InputData.XcManual
End Property

Property Let in_XcManual(tXcManual As Single)
    InputData.XcManual = tXcManual
End Property

Property Get in_YcManual() As Single
    in_YcManual = InputData.YcManual
End Property

Property Let in_YcManual(tYcManual As Single)
    InputData.YcManual = tYcManual
End Property

Property Get in_CheckCentroid() As Boolean
    in_CheckCentroid = InputData.CheckCentroid
End Property

Property Let in_CheckCentroid(tCheckCentroid As Boolean)
    InputData.CheckCentroid = tCheckCentroid
End Property

Public Property Get in_a(ByVal Index1 As Integer, _
                           ByVal Index2 As Integer) As Single
    
    If Index1 <= UBound(InputData.a, 1) And _
       Index2 <= UBound(InputData.a, 2) Then in_a = InputData.a(Index1, Index2)

End Property
Public Property Let in_a(ByVal Index1 As Integer, _
                           ByVal Index2 As Integer, _
                           NewNumber As Single)
Dim mArray() As Single
         mArray = InputData.a
    
    If Index1 > UBound(InputData.a, 1) Then ReDim InputData.a(Index1, UBound(InputData.a, 2))
    If Index2 > UBound(InputData.a, 2) Then ReDim InputData.a(UBound(InputData.a, 1), Index2)
    
    For ISum1 = LBound(mArray, 1) To UBound(mArray, 1)
        For ISum2 = LBound(mArray, 2) To UBound(mArray, 2)
            InputData.a(ISum1, ISum2) = mArray(ISum1, ISum2)
        Next ISum2
    Next ISum1
    
    InputData.a(Index1, Index2) = NewNumber

End Property

Private Sub Class_Initialize()
    ReDim InputData.a(0, 0)
End Sub


Function out_Xc() As Single
    out_Xc = OutputData.Xc
End Function

Function out_Yc() As Single
    out_Yc = OutputData.Yc
End Function

Property Get CutOrFill(x As Long, y As Long) As Single
    On Error Resume Next
    CutOrFill = dZ(x, y)
End Property

'########### Tastih Arazi v1.0 CLASS ################
'########### Programmer: Nabi Karamalizadeh #########
'########### http://www.Tastih.Nabi.ir/ #############
'########### Copyright 2007 All rights reserved. ####

